import numpy as np
import matplotlib.pyplot as plt
from scipy.io import loadmat
from scipy.sparse.linalg import svds
from KRR import KRR

# load data
data = loadmat("mnistSubset.mat")
X = data['X']
trueLabels = data['trueLabels'][:,0]

# only consider digits 1 and 2 (labels 2 and 3)
K = 2
Xtrain = np.array([]).reshape(784, 0)
ytrain = np.array([]).reshape(0, 1)
Xtest = np.array([]).reshape(784, 0)
ytest = np.array([]).reshape(0, 1)
for kk in range(1,K+1):
    Xk = X[:, np.argwhere(trueLabels==kk+1)[:,0]]
    Xtrain = np.append(Xtrain, Xk[:, :100], axis=1)
    Xtest = np.append(Xtest, Xk[:, 100:], axis=1)
    ytrain = np.append(ytrain, kk*np.ones([100, 1]), axis=0)
    ytest = np.append(ytest, kk*np.ones([100, 1]), axis=0)

# make labels +1/-1
ytrain = (2*(ytrain - 1) - 1)[:,0]
ytest = (2*(ytest - 1) - 1)[:,0]

## YOUR CODE
# reduce dimension of data using PCA and plot

# train KRR classifier on (Xtrain,ytrain) and predict on (Xtest)

## plot separator
#xx = np.linspace(min(Xtrain[0,:]), max(Xtrain[0,:]), 50)
#yy = np.linspace(min(Xtrain[1,:]), max(Xtrain[1,:]), 50)
#XX, YY = np.meshgrid(xx,yy)
#xl = XX.reshape((-1,1), order='F')
#yl = YY.reshape((-1,1), order='F')
#xx = np.concatenate((xl, yl), axis=1)
#_, yy = KRR(Xtrain.T, ytrain, lam, sigma, xx)
#plt.contour(XX, YY, yy.reshape((50,50), order='F'), 0)
#plt.show()

# compute train and test error
